<?php
$kinyonga_default_options = array(
	 'nav_menu1_show'     => null, //on,null
	 'nav_menu1_type'     => 'categories', //categories, pages
	 'nav_menu1_dropdown' => 'on', //on,null
	 'header_image'       => 'header.jpg', //header.jpg, any uplaoded image valid filename
	 'slider_enabled'     => null, //on,null
	 'slider_images'      => array(), //header.jpg, any uplaoded image valid filename
	 'anim_speed'         => 500, //300-1000
	 'pause_time'         => 5000, //1000-10000
	 'nav_menu2_show'     => 'on', //on,null
	 'nav_menu2_type'     => 'pages', //pages, categories
	 'nav_menu2_dropdown' => 'on', //on,null
	 'sidebars'           => 'both', //right,left,none,both
	 'background'         => '4', //1,2,3,4,5
);

if(!defined("HEADER_IMAGE_UPLOAD_DIR")) define("HEADER_IMAGE_UPLOAD_DIR", TEMPLATEPATH . "/images/header"); 
if(!defined("HEADER_IMAGE_UPLOAD_DIR_URL")) define("HEADER_IMAGE_UPLOAD_DIR_URL", get_bloginfo('template_url') . "/images/header");
if(!defined("MAX_FILE_SIZE")) define("MAX_FILE_SIZE", 102400); 
if(!defined("HEADER_IMAGE_WIDTH")) define("HEADER_IMAGE_WIDTH", 990);
if(!defined("HEADER_IMAGE_HEIGHT")) define("HEADER_IMAGE_HEIGHT", 86);

add_action('admin_print_scripts', 'add_kinyonga_admin_js');
function add_kinyonga_admin_js() {
	wp_enqueue_script('admin_js', get_bloginfo('template_url').'/js/admin.js');
}

add_action('admin_print_styles', 'add_kinyonga_admin_css');
function add_kinyonga_admin_css() {
	wp_enqueue_style('admin_css', get_bloginfo('template_url').'/css/admin.css');
}

add_action('admin_menu', 'add_kinyonga_theme_options');
function add_kinyonga_theme_options() {
	add_theme_page(__('Kinyonga Options'), __('Kinyonga Options'), 'edit_themes', basename(__FILE__), 'kinyonga_theme_options');
}

//check if header image file was uploaded
if(isset($_FILES['header_image_upload']['error']) && $_FILES['header_image_upload']['error']==0){
	//header.jpg cannot be uploaded, it's the default header
	if($_FILES['header_image_upload']['name'] != $kinyonga_default_options['header_image']){
		//move uploaded file to header image upload dir
		$path = $_FILES['header_image_upload']['tmp_name'];
		$new_path = HEADER_IMAGE_UPLOAD_DIR . "/" . 
			basename($_FILES['header_image_upload']['name']);
		move_uploaded_file($path,$new_path);
	}
}

//list header images
function get_header_images($options, $image_type='header'){
	global $kinyonga_default_options;
	echo '<table class="header_images">';
	if ($handle = opendir(HEADER_IMAGE_UPLOAD_DIR)) {
		while (false !== ($file_name = readdir($handle))) :
			if ($file_name != "." && $file_name != "..") :
			switch($file_name){
				case $kinyonga_default_options['header_image']:
					$title = ' title="Deafault header image"';
					break;
				case $options['header_image']:
					$title = ' title="Active header image"';
					break;
				default:
					$title = ' title="Inactive header image"';
					break;
			}
			if($image_type == 'header'){
			?>
                <tr>
                    <td><input type="radio" name="header_image" value="<?php echo $file_name; ?>" title="Enable"<?php if($options['header_image']==$file_name) echo ' checked="checked"'; ?> /></td>
                    <td><img src="<?php echo HEADER_IMAGE_UPLOAD_DIR_URL; ?>/<?php echo $file_name; ?>" height="<?php echo round(HEADER_IMAGE_HEIGHT/4); ?>" width="<?php echo round(HEADER_IMAGE_WIDTH/3); ?>"<?php echo $title; ?> /></td>
                    <td><input type="checkbox" name="header_images_to_delete[]" value="<?php echo $file_name; ?>" title="Delete"<?php if($file_name==$kinyonga_default_options['header_image'] || $file_name==$options['header_image']) echo ' disabled="disabled"';//default or active header image cannot be removed ?> /></td>
                </tr>
			<?php
			}else{
				?>
				<tr>
                    <td><input type="checkbox" name="slider_images[]" value="<?php echo $file_name; ?>"<?php used_in_slider($options['slider_images'], $file_name); ?> /></td>
                    <td><img src="<?php echo HEADER_IMAGE_UPLOAD_DIR_URL; ?>/<?php echo $file_name; ?>" height="<?php echo round(HEADER_IMAGE_HEIGHT/4); ?>" width="<?php echo round(HEADER_IMAGE_WIDTH/3); ?>" /></td>
				</tr>
            	<?php
			}
			endif;
		endwhile;
		closedir($handle);
	}	
	echo '</table>';
}

function delete_header_images($header_images){
	global $kinyonga_default_options;
	foreach($header_images as $header_image){
		if($header_image != $kinyonga_default_options['header_image'])
			unlink(HEADER_IMAGE_UPLOAD_DIR."/".$header_image);
	}
}

function used_in_slider($slider_images, $file_name){
	if(is_array($slider_images) && !empty($slider_images)){
		foreach($slider_images as $slider_image){
			if($slider_image==$file_name){
				echo ' checked="checked"';
				return;
			}
		}
	}
}

function kinyonga_theme_options() {
	global $kinyonga_default_options;
	if(isset($_POST['kinyonga_save_options'])) {
		echo '<div id="message" class="updated fade"><p><strong>'.__('Options saved.').'</strong></p></div>';
		$new_options = array();
		//check if submitted options are valid
		if((int)$_POST['pause_time']<1000 || (int)$_POST['pause_time']>10000) $_POST['pause_time']=5000;
		if((int)$_POST['anim_speed']<300 || (int)$_POST['anim_speed']>1000) $_POST['anim_speed']=500;
		foreach($kinyonga_default_options as $k => $v){
			$new_options[$k] = @$_POST[$k];
		}
		update_option('kinyonga',$new_options);
	}
	$options = get_theme_options();
	//header_images_to_delete
	if(isset($_POST['header_images_to_delete']) && !empty($_POST['header_images_to_delete']))
		delete_header_images($_POST['header_images_to_delete']);
?>
<div class='wrap'>
	<h2><?php _e('kinyonga Options'); ?></h2>
	<form action="" method="post" name="kinyonga_form" id="kinyonga_form" enctype="multipart/form-data">
    <div class="container_outer container_closed">
        <h4 class="header">First Top Navigation Menu</h4>
        <div class="container_inner">
            <table class="tbo">
                <tbody>
                    <tr>
                        <th><?php _e('Enabled'); ?></th>
                        <td><input name="nav_menu1_show" type="checkbox"<?php if($options['nav_menu1_show']) echo ' checked="checked"'; ?> /></td>
                    </tr>
                    <tr>
                        <th><?php _e('Menu Contains'); ?></th>
                        <td>
                        	<label>
                            	<input name="nav_menu1_type" type="radio" value="categories"<?php if($options['nav_menu1_type']=="categories") echo ' checked="checked"'; ?> /> 
                            	<?php _e('Categories'); ?>  
                        	</label> 
                            <label>
                            	<input name="nav_menu1_type" type="radio" value="pages"<?php if($options['nav_menu1_type']=="pages") echo ' checked="checked"'; ?> />
                                 <?php _e('Pages'); ?>
							</label>
                        </td>
                    </tr>
                    <tr>
                        <th><?php _e('Dropdown Enabled'); ?></th>
                        <td><input name="nav_menu1_dropdown" type="checkbox"<?php if($options['nav_menu1_dropdown']) echo ' checked="checked"'; ?> /></td>
                    </tr>
                </tbody>
            </table>
        </div>
	</div>
    <div class="container_outer container_closed">
        <h4 class="header">Header Image</h4>
       <div class="container_inner">
            <table class="tbo">
                <tbody>
                    <tr>
                        <th><?php _e('Upload image'); ?></th>
                        <td>
                        	<input type="hidden" name="MAX_FILE_SIZE" value="<?php echo MAX_FILE_SIZE ?>" />
                            <input name="header_image_upload" type="file" />
                            <br />
                            <span class="note">Note: header image size has to be under <?php echo MAX_FILE_SIZE/1024; ?> kB; its dimentions should be <?php echo HEADER_IMAGE_WIDTH; ?>x<?php echo HEADER_IMAGE_HEIGHT; ?>px.</span>
                        </td>
                    </tr>
                    <tr>
                        <th><?php _e('Enable/delete image'); ?></th>
                        <td>
                            <?php get_header_images($options); ?>
                        	<span class="note">Note: use radio buttons to enable header image and check boxe(s) to remove image(s); default and/or active header image cannot be removed.</span>
                        </td>
                    </tr>
                </tbody>
            </table>
        </div>
	</div>
    <div class="container_outer container_closed">
        <h4 class="header">Slider</h4>
        <div class="container_inner">
            <table class="tbo">
                <tbody>
                    <tr>
                        <th><?php _e('Enabled'); ?></th>
                        <td><input name="slider_enabled" type="checkbox"<?php if(isset($options['slider_enabled'])) echo ' checked="checked"'; ?> /><br /><span class="note">Note: if slider is enabled, header image settings are ignored; use header image options to upload/delete images.</span></td>
                    </tr>
                    <tr>
                        <th><?php _e('Images to use in slider'); ?></th>
                        <td><?php get_header_images($options, 'slider'); ?></td>
                    </tr>
                    <tr>
                        <th>Animation Speed</th>
                        <td><input type="text" name="anim_speed" value="<?php if(isset($options['anim_speed'])) echo $options['anim_speed']; ?>" /><span class="note">(300-1000)</span></td>
                    </tr>
                    <tr>
                        <th>Pause Time</th>
                        <td><input type="text" name="pause_time" value="<?php if(isset($options['pause_time'])) echo $options['pause_time']; ?>" /><span class="note">(1000-10000)</span></td>
                    </tr>
                </tbody>
            </table>
        </div>
	</div>
    <div class="container_outer container_closed">
        <h4 class="header">Second Top Navigation Menu</h4>
        <div class="container_inner">
            <table class="tbo">
                <tbody>
                    <tr>
                        <th><?php _e('Enabled'); ?></th>
                        <td><input name="nav_menu2_show" type="checkbox"<?php if($options['nav_menu2_show']) echo ' checked="checked"'; ?> /></td>
                    </tr>
                    <tr>
                        <th><?php _e('Menu Contains'); ?></th>
                        <td>
                        	<label>
                            	<input name="nav_menu2_type" type="radio" value="pages"<?php if($options['nav_menu2_type']=="pages") echo ' checked="checked"'; ?> />
                                 <?php _e('Pages'); ?>
							</label>
                            <label>
                            	<input name="nav_menu2_type" type="radio" value="categories"<?php if($options['nav_menu2_type']=="categories") echo ' checked="checked"'; ?> /> 
                            	<?php _e('Categories'); ?>  
                        	</label> 
                        </td>
                    </tr>
                    <tr>
                        <th><?php _e('Dropdown Enabled'); ?></th>
                        <td><input name="nav_menu2_dropdown" type="checkbox"<?php if($options['nav_menu2_dropdown']) echo ' checked="checked"'; ?> /></td>
                    </tr>
                </tbody>
            </table>
        </div>
	</div>
    <div class="container_outer container_closed">
        <h4 class="header">Sidebars</h4>
        <div class="container_inner">
            <table class="tbo">
                <tbody>
                    <tr>
                        <th>Sidebar position</th>
                        <td>
                        	<label><input type="radio" name="sidebars" value="left"<?php if($options['sidebars']=='left') echo ' checked="checked"'; ?> />Left</label>
                        	<label><input type="radio" name="sidebars" value="right"<?php if($options['sidebars']=='right') echo ' checked="checked"'; ?> />Right</label>
                            <label><input type="radio" name="sidebars" value="both"<?php if($options['sidebars']=='both') echo ' checked="checked"'; ?> />Both</label>
                            <label><input type="radio" name="sidebars" value="none"<?php if($options['sidebars']=='none') echo ' checked="checked"'; ?> />None</label>
                        </td>
                    </tr>
                </tbody>
            </table>
        </div>
	</div>
    <div class="container_outer container_closed">
        <h4 class="header">Color and Background</h4>
        <div class="container_inner">
            <table class="tbo">
                <tbody>
                    <tr>
                        <th>Select Color and Background Scheme</th>
                        <td>
                        	<label><input type="radio" name="background" value="1"<?php if($options['background']=='1') echo ' checked="checked"'; ?> /><span class="pbc1">1</span></label>
                        	<label><input type="radio" name="background" value="2"<?php if($options['background']=='2') echo ' checked="checked"'; ?> /><span class="pbc2">2</span></label>
                            <label><input type="radio" name="background" value="3"<?php if($options['background']=='3') echo ' checked="checked"'; ?> /><span class="pbc3">3</span></label>
                            <label><input type="radio" name="background" value="4"<?php if($options['background']=='4') echo ' checked="checked"'; ?> /><span class="pbc4">4</span></label>
                            <label><input type="radio" name="background" value="5"<?php if($options['background']=='5') echo ' checked="checked"'; ?> /><span class="pbc5">5</span></label>
                        </td>
                    </tr>
                </tbody>
            </table>
        </div>
	</div>
    <p class="submit">
    	<input type="submit" name="kinyonga_save_options" class="button-primary" value="<?php _e('Save Changes'); ?>" />
    </p>
    </form>
</div>
<?php
}

function get_theme_options() {
	global $kinyonga_default_options;
	if(!$theme_options = get_option('kinyonga')) {
		//add default options to db
		add_option('kinyonga',$kinyonga_default_options);
		$theme_options = get_option('kinyonga');
	}
	//return options as array
	return $theme_options;
}

$options = get_theme_options();

function nav_menu($nav_menu) {
	global $options;
	$nav_menu_show = "nav_menu" . $nav_menu . "_show";
	$nav_menu_type = "nav_menu" . $nav_menu . "_type";
	$nav_menu_dropdown = "nav_menu" . $nav_menu . "_dropdown";
	if($options[$nav_menu_dropdown]) $depth = "";
	else $depth = "&depth=1";
	if($options[$nav_menu_show]){
		echo "<ul>";
		switch($options[$nav_menu_type]){
			case 'categories':
				wp_list_categories('title_li='.$depth);
				break;
			case 'pages':
				wp_list_pages('title_li='.$depth);
				break;
		}
		echo "</ul>";
	}	
}

function get_slider() {
	global $options;
	$slider_images_html = '';
	$c = '';
	$slider_images = $options['slider_images'];
	if(is_array($slider_images) && !empty($slider_images)){
		foreach($slider_images as $slider_image){
			$slider_images_html .= '<img src="'.HEADER_IMAGE_UPLOAD_DIR_URL.'/'.$slider_image.'" />';
		}
	}
	$c .= '<div id="slidecontainer"><div id="slider">';
	$c .= $slider_images_html;
	$c .= '</div></div>';
	return $c;
}

function get_theme_css_classes($type) {
	global $options;
	if($type!='body'):
		switch($options['sidebars']){
			case 'left':
				$class_content       = ' cls';
				$class_sidebar_left  = ' sls';
				$class_sidebar_right = '';
				$class_content_bg_t  = 'cwt';
				$class_content_bg_c  = 'cwc';
				$class_content_bg_b  = 'cwb';
				$class_sidebar_bg_t  = 'swt';
				$class_sidebar_bg_c  = 'swc';
				$class_sidebar_bg_b  = 'swb';
				break;
			case 'right':
				$class_content       = 'crs';
				$class_sidebar_left  = '';
				$class_sidebar_right = 'srs';
				$class_content_bg_t  = 'cwt';
				$class_content_bg_c  = 'cwc';
				$class_content_bg_b  = 'cwb';
				$class_sidebar_bg_t  = 'swt';
				$class_sidebar_bg_c  = 'swc';
				$class_sidebar_bg_b  = 'swb';
				break;
			case 'both':
				$class_content       = ' cbs';
				$class_sidebar_left  = 'slbs';
				$class_sidebar_right = 'srbs';
				$class_content_bg_t  = 'cnt';
				$class_content_bg_c  = 'cnc';
				$class_content_bg_b  = 'cnb';
				$class_sidebar_bg_t  = 'snt';
				$class_sidebar_bg_c  = 'snc';
				$class_sidebar_bg_b  = 'snb';
				break;
			case 'none':
				$class_content       = ' cns';
				$class_content_bg_t  = 'cbt';
				$class_content_bg_c  = 'cbc';
				$class_content_bg_b  = 'cbb';
				$class_sidebar_left  = '';
				$class_sidebar_right = '';
				break;
		}
	else:
		switch($options['background']){
			case '1':
				$class_page = ' pbc1';
				break;
			case '2':
				$class_page = ' pbc2';
				break;
			case '3':
				$class_page = ' pbc3';
				break;
			case '4':
				$class_page = ' pbc4';
				break;
			case '5':
				$class_page = ' pbc5';
				break;
		}
	endif;
	switch($type){
		case 'content':
			echo $class_content;
			break;
		case 'content-bg-t':
			echo $class_content_bg_t;
			break;
		case 'content-bg-c':
			echo $class_content_bg_c;
			break;
		case 'content-bg-b':
			echo $class_content_bg_b;
			break;
		case 'sidebar-left':
			echo $class_sidebar_left;
			break;
		case 'sidebar-bg-t':
			echo $class_sidebar_bg_t;
			break;
		case 'sidebar-bg-c':
			echo $class_sidebar_bg_c;
			break;
		case 'sidebar-bg-b':
			echo $class_sidebar_bg_b;
			break;
		case 'sidebar-right':
			echo $class_sidebar_right;
			break;
		case 'page':
			echo $class_page;
			break;
		case 'body':
			return $class_page;
			break;
	}
}

function get_content_class() {
	get_theme_css_classes('content');
}

function get_content_bg_t_class() {
	get_theme_css_classes('content-bg-t');
}

function get_content_bg_c_class() {
	get_theme_css_classes('content-bg-c');
}

function get_content_bg_b_class() {
	get_theme_css_classes('content-bg-b');
}

function get_sidebar_left_class() {
	get_theme_css_classes('sidebar-left');
}

function get_sidebar_right_class() {
	get_theme_css_classes('sidebar-right');
}

function get_sidebar_bg_t_class() {
	get_theme_css_classes('sidebar-bg-t');
}

function get_sidebar_bg_c_class() {
	get_theme_css_classes('sidebar-bg-c');
}

function get_sidebar_bg_b_class() {
	get_theme_css_classes('sidebar-bg-b');
}

function get_page_class() {
	get_theme_css_classes('page');
}

function get_body_css_class() {
	return get_theme_css_classes('body');
}

//JS and styles for front end
add_action('init', 'kinyonga_js_css');

function kinyonga_js_css() {
	global $options;
	if($options['slider_enabled']){
		wp_enqueue_script('jquery');
		wp_enqueue_script('slider', get_bloginfo('template_url').'/js/slider.js');
		wp_enqueue_style('slider', get_bloginfo('template_url').'/css/slider.css');
	}
}

if(function_exists('register_sidebars')) register_sidebars(2);
?>
